package fr.univlehavre.projet.carnet;

import fr.univlehavre.projet.entree.*;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.Arrays;
import java.util.Collections;

public class Carnet {

	private Entree[] entrees;
	private Entree[] selectionnees;
	private int      compteurEntrees;
	private int      compteurSelectionnees;

	public Carnet (){
		entrees       = new Entree[100];
		selectionnees = new Entree[100];

		compteurEntrees = compteurSelectionnees = 0;
	}



	public void lectureFichier(String nomFichier) throws IOException {

		String[] contenueLigne;

		String[] contenueId = new String[100];
		int cpt = 0;


		FileReader fr = new FileReader(nomFichier);
		BufferedReader br = new BufferedReader(fr);

		GENRE genre;
		Personne personne;
		Societe societe;

		for (String ligne = br.readLine(); ligne != null; ligne = br.readLine()){

			contenueLigne = ligne.split(";");

			if (contenueLigne[1].equals("SOCIETE")) {
				ajouterEntree(new Societe(contenueLigne[2]));
			}
			else if (contenueLigne[1].equals("PERSONNE") && contenueLigne.length > 6) {

				contenueId[cpt] = contenueLigne[0] + ";" + contenueLigne[5] + ";" + contenueLigne[6];

				if (contenueLigne[4].equals("F"))
					genre = GENRE.FEMME;
				else
					genre = GENRE.HOMME;

				if(!contenueLigne[5].equals("") &&
					Integer.parseInt(contenueLigne[5]) <= compteurEntrees) {
					personne = (Personne) entrees[Integer.parseInt(contenueLigne[5]) - 1];
				}
				else {
					personne = null;
				}

				if( !contenueLigne[6].equals("") &&
					Integer.parseInt(contenueLigne[6]) <= compteurEntrees) {
					societe = (Societe) entrees[Integer.parseInt(contenueLigne[6]) - 1];
				}
				else {
					societe = null;
				}

				cpt++;


				ajouterEntree(new Personne(contenueLigne[3], contenueLigne[2].split(","), genre,
					personne, contenueLigne[7], societe));

			}


		}

		String[] initId;
		for (int i = 0; i< cpt; i++){
			initId = contenueId[i].split(";");
			Personne p = (Personne) entrees[Integer.parseInt(initId[0])-1];

			if (initId.length > 1 && !initId[1].equals("") && Integer.parseInt(initId[0]) < Integer.parseInt(initId[1]) &&
				Integer.parseInt(initId[1])-1 < compteurEntrees) {
				p.setConjoint((Personne) entrees[Integer.parseInt(initId[1])-1]);
			}

			if (initId.length > 2 && !initId[2].equals("") && Integer.parseInt(initId[0]) < Integer.parseInt(initId[2]) &&
				Integer.parseInt(initId[2])-1 < compteurEntrees) {
				p.setSociete((Societe) entrees[Integer.parseInt(initId[2])-1]);
			}

			entrees[Integer.parseInt(initId[0])-1] = p;

		}

		br.close();
		fr.close();
	}

	public Entree getEntree(int id){
		return entrees[id];
	}

	public void ajouterEntree(Entree entree){
		this.entrees[this.compteurEntrees++] = entree;
	}


	public int getCompteurEntrees() {
		return compteurEntrees;
	}


	public Entree[] recherche(String s){
		Entree[] entreesSelect = new Entree[compteurEntrees];

		int cpt = 0;

		for (Entree e : entrees)
			if (e.recherche(s))
				entreesSelect[cpt++] = e;

		return entreesSelect;
	}


	public void selection (Entree[] e){
		selectionnees = e;
		compteurSelectionnees = e.length;
	}

	public void selection (String s){
		selection(recherche(s));
	}

	public void selection (Entree e){
		selectionnees[compteurSelectionnees++] = e;
	}

	public void deselection(){
		selectionnees = new Entree[100];
		compteurSelectionnees = 0;
	}


	public void affichage(Ordre o, Presentation p, Sens s){
		System.out.println(affichageByTable(o, p, s, compteurEntrees, entrees));
	}

	public String affichageTest(Ordre o, Presentation p, Sens s){
		return affichageByTable(o, p, s, compteurEntrees, entrees);
	}

	public void affichageSelection(Ordre o, Presentation p, Sens s){
		System.out.println(affichageByTable(o, p, s, compteurSelectionnees, selectionnees));
	}

	private String affichageByTable(Ordre o, Presentation p, Sens s, int compteur, Entree[] entree) {
		String[] tmp = new String[compteur];
		String sRet  = "";

		int cpt = 0;

		for (int i = 0; i<compteurEntrees; i++)
			tmp[cpt++] = entrees[i].toString(p, s);

		if (o.equals(Ordre.Croissant))
			Arrays.sort(tmp);
		else
			Arrays.sort(tmp, Collections.reverseOrder());


		for (String sortie : tmp){
			sRet += sortie + "\n";
		}

		return sRet;
	}

}
