package fr.univlehavre.projet;

import fr.univlehavre.projet.carnet.Carnet;
import fr.univlehavre.projet.carnet.Ordre;
import fr.univlehavre.projet.entree.Presentation;
import fr.univlehavre.projet.entree.Sens;
import org.junit.jupiter.api.Test;

import java.io.File;
import java.io.IOException;

import static org.junit.jupiter.api.Assertions.*;

public class AffichageTest {

	@Test
	public void affichageTestOrdreCroissant() throws IOException {


		Carnet carnet = new Carnet();

		ClassLoader classLoader = getClass().getClassLoader();
		File file = new File(classLoader.getResource("carnet.csv").getFile());

		carnet.lectureFichier(file.getAbsolutePath());

		assertEquals("Ecole de sorcellerie Poudlard\n" +
			"Ecole de sorcellerie Rebelle\n" +
			"M. Dumbledore Albus P. W. B.  (Ecole de sorcellerie Poudlard)\n" +
			"M. Potter Harry J.  (Ecole de sorcellerie Poudlard)\n" +
			"Mme Weasley Ginny (Ecole de sorcellerie Rebelle)\n", carnet.affichageTest(Ordre.Croissant, Presentation.SIMPLE, Sens.NOM_PRENOMS));

	}

	@Test
	public void affichageTestOrdreDecroissant() throws IOException {


		Carnet carnet = new Carnet();

		ClassLoader classLoader = getClass().getClassLoader();
		File file = new File(classLoader.getResource("carnet.csv").getFile());

		carnet.lectureFichier(file.getAbsolutePath());

		assertEquals("Mme Weasley Ginny (Ecole de sorcellerie Rebelle)\n" +
			"M. Potter Harry J.  (Ecole de sorcellerie Poudlard)\n" +
			"M. Dumbledore Albus P. W. B.  (Ecole de sorcellerie Poudlard)\n" +
			"Ecole de sorcellerie Rebelle\n" +
			"Ecole de sorcellerie Poudlard\n", carnet.affichageTest(Ordre.Decroissant, Presentation.SIMPLE, Sens.NOM_PRENOMS));

	}

}
